<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>

<%@ page import="org.wso2.carbon.ejbservices.ui.EJBServicesAdminClient" %>
<%@ page import="java.util.Map" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>

<!-- This page is included to display messages which are set to request scope or session scope -->
<jsp:include page="../dialog/display_messages.jsp"/>

<script type="text/javascript" src="js/ejbservices.js"></script>

<script type="text/javascript">

    function validateServiceParameters() {
        document.updateServiceParamForm.submit();
    }

</script>

<%
    String serviceName = request.getParameter("serviceName");
    Map paramMap = null;
    try {
        EJBServicesAdminClient serviceAdmin = new EJBServicesAdminClient(config.getServletContext(), session);
        paramMap = serviceAdmin.getServiceParameters(serviceName);
    } catch (Exception e) {
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request);
 %>
        <script type="text/javascript">
               location.href = "index.jsp";
        </script>
<%
        return;
    }
%>


<fmt:bundle basename="org.wso2.carbon.ejbservices.ui.i18n.Resources">
<carbon:breadcrumb label="ejb.service.parameters"
		resourceBundle="org.wso2.carbon.ejbservices.ui.i18n.Resources"
		topPage="false" request="<%=request%>" />
    <div id="middle">
        <h2><fmt:message key="ejb.service.parameters"/></h2>

        <div id="workArea">

            <fieldset style="border: medium none ;">

                <div tabindex="-1" id="formset">

                    <form name="updateServiceParamForm" method="post"
                          action="update_service_param.jsp">
                        <fieldset>
                            <legend><fmt:message key="edit.ejb.service.parameters"/></legend>


                            <div tabindex="-1" id="param_div">

                                <div tabindex="-1" style="clear: both;">
                                    <label style="width: 25%;"><fmt:message key="remote.interface.name"/></label>
                                    <%
                                        String remoteInterfaceName = (String) paramMap.get("remoteInterfaceName");
                                        if (remoteInterfaceName == null) {
                                            remoteInterfaceName = "";
                                        }
                                    %>
                                    <input size="100" value="<%=remoteInterfaceName%>"
                                           id="remoteInterfaceName" name="remoteInterfaceName"
                                           tabindex="0" type="text"/>
                                </div>

                                <div tabindex="-1" style="clear: both;">
                                    <label style="width: 25%;"><fmt:message key="home.interface.name"/></label>
                                    <%
                                        String homeInterfaceName = (String) paramMap.get("homeInterfaceName");
                                        if (homeInterfaceName == null) {
                                            homeInterfaceName = "";
                                        }
                                    %>
                                    <input
                                            size="100" value="<%=homeInterfaceName%>"
                                            id="homeInterfaceName" name="homeInterfaceName"
                                            tabindex="1" type="text"/>
                                </div>

                                <div tabindex="-1" style="clear: both;">
                                    <label style="width: 25%;"><fmt:message key="bean.jndi.name"/></label>
                                    <%
                                        String beanJndiName = (String) paramMap.get("beanJndiName");
                                        if (beanJndiName == null) {
                                            beanJndiName = "";
                                        }
                                    %>
                                    <input size="100" value="<%=beanJndiName%>"
                                           id="beanJndiName" name="beanJndiName" tabindex="2"
                                           type="text"/>
                                </div>

                                <div tabindex="-1" style="clear: both;">
                                    <label style="width: 25%;"><fmt:message key="jndi.user"/></label>
                                    <%
                                        String jndiUser = (String) paramMap.get("jndiUser");
                                        if (jndiUser == null) {
                                            jndiUser = "";
                                        }
                                    %>
                                    <input size="100" value="<%=jndiUser%>" id="jndiUser"
                                           name="jndiUser" tabindex="3" type="text"/>
                                </div>

                                <div tabindex="-1" style="clear: both;">
                                    <label style="width: 25%;"><fmt:message key="jndi.password"/></label>
                                    <%
                                        String jndiPassword = (String) paramMap.get("jndiPassword");
                                        if (jndiPassword == null) {
                                            jndiPassword = "";
                                        }
                                    %>
                                    <input size="100" value="<%=jndiPassword%>" id="jndiPassword"
                                           name="jndiPassword" tabindex="4" type="text"/>

                                </div>

                                <div tabindex="-1" style="clear: both;">
                                    <label style="width: 25%;"><fmt:message key="provider.url"/></label>
                                    <%
                                        String providerUrl = (String) paramMap.get("providerUrl");
                                        if (providerUrl == null) {
                                            providerUrl = "";
                                        }
                                    %>
                                    <input size="100" value="<%=providerUrl%>" id="providerUrl"
                                           name="providerUrl" tabindex="5" type="text"/>

                                </div>

                                <div tabindex="-1" style="clear: both;">
                                    <label style="width: 25%;"><fmt:message key="service.type"/></label>
                                    <%
                                        String serviceType = (String) paramMap.get("serviceType");
                                        if (serviceType == null) {
                                            serviceType = "";
                                        }
                                    %>
                                    <input size="100" value="<%=serviceType%>"
                                           id="serviceTypeDisabled" tabindex="6" disabled="true"
                                           type="text"/>
                                    <input type="hidden" id="serviceType" name="serviceType"
                                           value="<%=serviceType%>"/>
                                </div>

                                <div tabindex="-1" style="clear: both;">
                                    <label style="width: 25%;"><fmt:message key="jndi.context.class"/></label>
                                    <%
                                        String jndiContextClass = (String) paramMap.get("jndiContextClass");
                                        if (jndiContextClass == null) {
                                            jndiContextClass = "";
                                        }
                                    %>
                                    <input size="100" value="<%=jndiContextClass%>"
                                           id="jndiContextClass" name="jndiContextClass"
                                           tabindex="7"
                                           type="text"/>
                                </div>

                                <div tabindex="-1" style="clear: both;">
                                    <label style="width: 25%;"><fmt:message key="service.class"/></label>
                                    <%
                                        String ServiceClass = (String) paramMap.get("ServiceClass");
                                        if (ServiceClass == null) {
                                            ServiceClass = "";
                                        }
                                    %>
                                    <input size="100" value="<%=ServiceClass%>"
                                           id="ServiceClassDisabled" tabindex="8" disabled="true"
                                           type="text"/>
                                    <input type="hidden" id="ServiceClass" name="ServiceClass"
                                           value="<%=ServiceClass%>"/>
                                    <input type="hidden" id="serviceName" name="serviceName"
                                           value="<%=serviceName%>"/>
                                </div>
                            </div>

                        </fieldset>

                        <div tabindex="-1" class="buttonrowBottom">

                            <input value=" <fmt:message key="update"/> &gt; "
                                   onclick="javascript:validateServiceParameters();"
                                   id="updateServiceParameters"
                                   type="button"/>

                        </div>
                    </form>

                </div>

            </fieldset>

        </div>

    </div>
</fmt:bundle>